// pages/coupons.js
const app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo

wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    nav:[
      {
        type:'1',
        name:'可使用'
      },{
        type:'2',
        name:'已失效'
      }
    ],
    pageNo: 1,
    pageSize: 10,
    totalPages: 0,
    totalElements: 0,
    invalidTotalElements: 0,
    couponList: [],
    invalidCouponList: [],
    currentTab: 0,
    noMoreCoupon: false,
    noMoreCouponInvalid: false
  },
    //滑动切换
    swiperTab: function (e) {
      const {current} =  e.detail
      this.setData({
        currentTab: current
      });
      // 可使用
      if(current == 0){
        this.getCouponList(this.data.pageNo,this.data.pageSize,1)
      }else if( current == 1){
        // 失效
        this.getCouponList(this.data.pageNo,this.data.pageSize,0)
      }
    },
    //点击切换
    clickTab: function (e) {
      const {current} = e.target.dataset
      if (this.data.currentTab === current) {
        return false;
      } else {
        this.setData({
          currentTab: current
        })
      }
       // 可使用
      if( current == 0 ){
        this.getCouponList(this.data.pageNo,this.data.pageSize,1)
      }else if( current == 1){
        // 失效
        this.getCouponList(this.data.pageNo,this.data.pageSize,0)
      }

    },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad () {},
  /**
   * 生命周期函数--监听页面显示
   */
  onShow () {
    this.getCouponList(this.data.pageNo,this.data.pageSize,1)
  },
  handelPresentCouponCode(e) {
    let data = e.currentTarget.dataset
    wxService.router(`/pages/couponDetail/couponDetail`).search(data)
  },

  //获取优惠券列表
  getCouponList(pageNo,pageSize,status){
    wx.showLoading({
      title: '加载中'
    })
 
    const params = {
      status
    }
    wxService.post(`/coupon/coupon/listWithMember?number=${pageNo}&size=${pageSize}`, params).then(res => {
      const {result,data} = res.data
      if(result == 0){
         wx.hideLoading()
         this.setData({
          couponList: this.data.pageNo == 1? [...data.content]: [...this.data.couponList,...data.content],
          totalPages: data.totalPages,
          totalElements: data.totalElements
         })
      }

    }).finally(() => {
      wx.hideLoading();
    })
  },
  /**
 * 页面相关事件处理函数--监听用户下拉动作
 */
  onPullDownRefresh: function () {},
  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if (this.data.pageNo < this.data.totalPages) {
      this.setData({
        pageNo: this.data.pageNo + 1,
      })
      if(this.data.currentTab == 0){
        this.getCouponList(this.data.pageNo,this.data.pageSize, 1)
      } else {
        this.getCouponList(this.data.pageNo,this.data.pageSize, 0)
      }
    } else {
      this.setData({
        noMoreCoupon: true
      })
    }
  },
})